<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;
use App\Http\Models\ItempopenerimaanioModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class ItempopenerimaanioService extends BaseService
{
    /**
     ItempopenerimaanioService constructor.
    */
    public function __construct()
    {
        parent::__construct();
        $this->model= new ItempopenerimaanioModel();
    }

	/**
	*  index function that get all data from database by default
	*  @return array|static[]
	*/
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	*  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	*  @param array $input
	*  @return array
	*/
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));
		$this->model->joinRelationItemId()->getQuery()->select([
			"itempopenerimaanio.quantity as quantity",
			"itempopenerimaanio.lotNumber",
			"itempopenerimaanio.receiptDate as tglMasuk",
			"itempopenerimaanio.qtyRemaining as jumlah",
			"itemId.id as id",
			"itemId.namaItem as namaItem",
			"itemId.part_number as part_number",
            "itemId.deskripsi as deskripsi",
            "itemId.category as category",
			"itemId.image as image",
			"itemId.item_price as harga",
            "itemId.UOM as UOM"
		])
		->where("itemId.enabled_flex", "=", "Y")
		->whereIn("itemId.type_id", $auth->arrCategory)
		->where("itempopenerimaanio.qtyRemaining", ">", 0)
		->where("itempopenerimaanio.status", "=", 0);

		if($auth->aplikasi != "HO") { 
			$this->model->getQuery()->where("itemId.kapalId", "=", $auth->kapalId); 
		}
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	public function store($input)
	{
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			$newInput = $this->getPrepare($input);
			// var_dump($input);
			// var_dump($newInput); dd();
			if(! empty($newInput)) {
				// $this->model->fill($newInput);
				/* if(! $this->model->insert($newInput)) {
					throw new \Exception();
				} */
				foreach($newInput as $row) {
					$itemBrg = new ItempopenerimaanioModel();
					$itemBrg->fill($row);
					if(! $itemBrg->save()) {
						throw new \Exception();
					}
				}
				return $this->model;
			}
		}
	}
	// id	penerimaanBarangId	itemId	receiptDate	quantity	location	lotNumber	subInventory	status
	private function getPrepare($input) {
		$data = [];
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $idx => $itemID) {
				$data[] = [	"ioNumber" => $input["ioNumber"],
							"itemId" => $itemID,
							"needBy" => $input["needBy"][$itemID],
							"quantity" => $input["quantity"][$itemID]
				];
			}
		}
		return $data;
	}

	public function updateQtyRemaining($input) {
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $itemID) {
				$itemPO = ItempopenerimaanioModel::where("ioNumber", $input["ioNumber"])->where("itemId", $itemID);
				$itemPO = $itemPO->first();
				if($itemPO) {
					if($itemPO->qtyRemaining < $input["quantity"][$itemID]) {
						throw new \Exception('Item quantity received is not valid.');
					} else {
						$itemPO->qtyRemaining -= $input["quantity"][$itemID];
						if($itemPO->qtyRemaining < 1) {
							$itemPO->status = 1;
							$itemPO->qtyRemaining = 0;
						}

						if(! $itemPO->save()) {
							throw new \Exception();
						}
					}
				}				
			}
		}
	}

	public function getStatusItems($ioNumber) {
		$nOpen = $this->model->getQuery()->selectRaw('COUNT("itempopenerimaanio"."id") as "nStatus"')
								->where("status", "=", 0)
								->where("ioNumber", "=", $ioNumber)
								->first();
		return $nOpen->nStatus;
	}

}